STDC_COUNT_ONES(3)

NAME
stdc_count_ones - count the ones in an integer

SYNOPSIS
libc
#include <stdbit.h>
unsigned int
stdc_count_ones_uc(unsigned char value);
unsigned int
stdc_count_ones_us(unsigned short value);
unsigned int
stdc_count_ones_ui(unsigned int value);
unsigned int
stdc_count_ones_ul(unsigned long value);
unsigned int
stdc_count_ones_ull(unsigned long long value);
unsigned int
stdc_count_ones(value);

DESCRIPTION
The stdc_count_ones_type() family of functions returns the number of bits set to 1 in value, where value is of type unsigned char, unsigned short, unsigned int, unsigned long, or unsigned long long for type being uc, us, ui, ul, or ull respectively. This is also known as the “population count” (popcount) or “Hamming weight” operation. The stdc_count_ones(value) type-generic macro picks the appropriate stdc_count_ones_type() function based on the type of value.

RETURN VALUES
Returns the number of bits set to 1 in value.

SEE ALSO
bit_count(3), stdbit(3), stdc_count_zeros(3), stdc_has_single_bit(3)

STANDARDS
The stdc_count_ones_type() family of functions and the stdc_count_ones() type-generic macro conform to isoC-2023.

HISTORY
The stdc_count_ones_type() family of functions and the stdc_count_ones() type-generic macro were added in FreeBSD 15.1.

AUTHOR
Robert Clausecker <fuz@FreeBSD.org>